﻿;16.02.2024 7:47 start code
;16.02.2024 12:54 ansi2utf8 14:50 almost done, check: wordwrap
;17.02.2024 09:26 wordwrap woho, maslenitsa\o/ 09:36 done(?)

Global gad.l=-1
Enumeration ; gadgets
  #s
  #d
  #u
EndEnumeration

;no equation
#CP_ACP = 0	    ; default to ANSI code page
#CP_OEMCP = 1   ; default to OEM code page
#CP_MACCP = 2   ; default to MAC code page
#CP_THREAD_ACP = 3	    ; current thread's ANSI code page
#CP_SYMBOL = 42         ; SYMBOL translations
#CP_UTF7 = 65000        ; UTF-7 translation
#CP_UTF8 = 65001        ; UTF-8 translation

Procedure encoder()
  If gad=#s
    s$=GetGadgetText(#s)
    ls=Len(s$)
    
    If ls
      d$=""
      i=1
      While i<ls+1
        c$=Mid(s$,i,1)
        i+1
        If c$="%"
          ;check to len
          h$=Mid(s$,i,2)
          i+2
          c$=Chr(Val("$"+h$))
        EndIf
        d$=d$+c$
      Wend
      ;check UTF8
      s$=d$
      If GetGadgetState(#u)
        dwSize=MultiByteToWideChar_(65001,0,d$,-1,0,0);CP_UTF8,#CP_ACP
        *fout1=AllocateMemory(dwSize*2)
        fw=MultiByteToWideChar_(65001,0,d$,-1,*fout1,dwSize)
        dwSize=WideCharToMultiByte_(0,0,*fout1,-1,0,0,0,0)
        *fout2=AllocateMemory(dwSize)
        fw=WideCharToMultiByte_(0,0,*fout1,-1,*fout2,dwSize,0,0)
        s$=PeekS(*fout2)
        FreeMemory(*fout2)
        FreeMemory(*fout1)
      EndIf
      SetGadgetText(#d,s$)
    EndIf
  ElseIf gad=#d
    s$=GetGadgetText(#d)
    ls=Len(s$)
    If ls
      If GetGadgetState(#u)
;https://www.purebasic.fr/english/viewtopic.php?t=12027
  ; s2u.s=s$
  *s2u_out = AllocateMemory(ls*2) 
  ;l = MultiByteToWideChar_(#CP_ACP,0,@s2u,-1,0,0) 
  l = MultiByteToWideChar_(#CP_ACP,0,@s$,-1,0,0) 
  ;l = MultiByteToWideChar_(#CP_ACP,0,@s2u,-1,*s2u_out,l) 
  l = MultiByteToWideChar_(#CP_ACP,0,@s$,-1,*s2u_out,l)
  l = WideCharToMultiByte_(#CP_UTF8,0,*s2u_out,-1,0,0,0,0) 
  *out2s=AllocateMemory(l);s2u_out2.s = Space(l)
  ;l = WideCharToMultiByte_(#CP_UTF8,0,*s2u_out,-1,@s2u_out2,l,0,0)
  l = WideCharToMultiByte_(#CP_UTF8,0,*s2u_out,-1,*out2s,l,0,0)
  ;ShowMemoryViewer(*out2s,1024)
  s$=PeekS(*out2s)
  FreeMemory(*out2s)
  FreeMemory(*s2u_out)
EndIf
d$=""
e$="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~"

For i=1 To Len(s$)
  c$=Mid(s$,i,1)
  h$="%"+RSet(Hex(Asc(c$)),2,"0")
  For j=1 To Len(e$)
    If c$=Mid(e$,j,1)
      h$=Mid(e$,j,1)
      Break
    EndIf
  Next j
  d$=d$+h$
Next i
      SetGadgetText(#s,d$)
    EndIf
  EndIf
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, "URI incoder/decoder by g0blinish", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
;  StringGadget(0,10,10,200,100,t$,#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
  StringGadget(#s, 0, 00, 640, 240, "",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT):GadgetToolTip(#s,"Decode %NN text from here");#ESB_DISABLE_BOTH
  
  StringGadget(#d, 0, 240, 640, 220, "",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT):GadgetToolTip(#d,"Encode text from here")
  CheckBoxGadget(#u,0,460,80,20,"UTF-8"):GadgetToolTip(#u,"UTF-8 convert")
EndIf

Repeat
  ev=WaitWindowEvent()
  If GetAsyncKeyState_(#VK_ESCAPE)&32768
    Break
  EndIf
  Select ev
    Case #PB_Event_Gadget
      Select EventGadget()
        Case #u
          encoder()
        Case #s
          If EventType()=#PB_EventType_Focus
            gad=#s
          ElseIf EventType()=#PB_EventType_Change
            encoder()
          EndIf
        Case #d
          If EventType()=#PB_EventType_Focus
            gad=#d
          ElseIf EventType()=#PB_EventType_Change
            encoder()
          EndIf
      EndSelect
  EndSelect
Until ev = #PB_Event_CloseWindow

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 28
; FirstLine = 8
; Folding = -
; EnableXP
; UseIcon = urie.ico
; Executable = uricoder.exe